<?php
/**
 * DiscountForReplace
 *
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\MarketingClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Ensi. Marketing.
 *
 * Маркетинг
 *
 * The version of the OpenAPI document: 1.0.0
 * 
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\MarketingClient\Dto;

use \ArrayAccess;
use \Ensi\MarketingClient\ObjectSerializer;

/**
 * DiscountForReplace Class Doc Comment
 *
 * @category Class
 * @package  Ensi\MarketingClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class DiscountForReplace implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'DiscountForReplace';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'user_id' => 'int',
        'seller_id' => 'int',
        'name' => 'string',
        'value_type' => 'int',
        'value' => 'float',
        'status' => 'int',
        'start_date' => '\DateTime',
        'end_date' => '\DateTime',
        'promo_code_only' => 'bool',
        'offers' => '\Ensi\MarketingClient\Dto\DiscountOffer[]',
        'brands' => '\Ensi\MarketingClient\Dto\DiscountBrand[]',
        'categories' => '\Ensi\MarketingClient\Dto\DiscountCategory[]',
        'segments' => '\Ensi\MarketingClient\Dto\DiscountSegment[]',
        'conditions' => '\Ensi\MarketingClient\Dto\DiscountCondition[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'user_id' => null,
        'seller_id' => null,
        'name' => null,
        'value_type' => null,
        'value' => 'float',
        'status' => null,
        'start_date' => 'date',
        'end_date' => 'date',
        'promo_code_only' => null,
        'offers' => null,
        'brands' => null,
        'categories' => null,
        'segments' => null,
        'conditions' => null
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static $openAPINullables = [
        'user_id' => false,
        'seller_id' => true,
        'name' => false,
        'value_type' => false,
        'value' => false,
        'status' => false,
        'start_date' => true,
        'end_date' => true,
        'promo_code_only' => false,
        'offers' => false,
        'brands' => false,
        'categories' => false,
        'segments' => false,
        'conditions' => false
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

        /**
     * Array of property to nullable mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPINullables()
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return array
     */
    public function getOpenAPINullablesSetToNull()
    {
        return $this->openAPINullablesSetToNull;
    }

    public function setOpenAPINullablesSetToNull($nullablesSetToNull)
    {
        $this->openAPINullablesSetToNull=$nullablesSetToNull;
        return $this;
    }

    /**
     * Checks if a property is nullable
     *
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        if (isset(self::$openAPINullables[$property])) {
            return self::$openAPINullables[$property];
        }

        return false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        if (in_array($property, $this->getOpenAPINullablesSetToNull())) {
            return true;
        }
        return false;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'user_id' => 'user_id',
        'seller_id' => 'seller_id',
        'name' => 'name',
        'value_type' => 'value_type',
        'value' => 'value',
        'status' => 'status',
        'start_date' => 'start_date',
        'end_date' => 'end_date',
        'promo_code_only' => 'promo_code_only',
        'offers' => 'offers',
        'brands' => 'brands',
        'categories' => 'categories',
        'segments' => 'segments',
        'conditions' => 'conditions'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'user_id' => 'setUserId',
        'seller_id' => 'setSellerId',
        'name' => 'setName',
        'value_type' => 'setValueType',
        'value' => 'setValue',
        'status' => 'setStatus',
        'start_date' => 'setStartDate',
        'end_date' => 'setEndDate',
        'promo_code_only' => 'setPromoCodeOnly',
        'offers' => 'setOffers',
        'brands' => 'setBrands',
        'categories' => 'setCategories',
        'segments' => 'setSegments',
        'conditions' => 'setConditions'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'user_id' => 'getUserId',
        'seller_id' => 'getSellerId',
        'name' => 'getName',
        'value_type' => 'getValueType',
        'value' => 'getValue',
        'status' => 'getStatus',
        'start_date' => 'getStartDate',
        'end_date' => 'getEndDate',
        'promo_code_only' => 'getPromoCodeOnly',
        'offers' => 'getOffers',
        'brands' => 'getBrands',
        'categories' => 'getCategories',
        'segments' => 'getSegments',
        'conditions' => 'getConditions'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('user_id', $data, null);
        $this->setIfExists('seller_id', $data, null);
        $this->setIfExists('name', $data, null);
        $this->setIfExists('value_type', $data, null);
        $this->setIfExists('value', $data, null);
        $this->setIfExists('status', $data, null);
        $this->setIfExists('start_date', $data, null);
        $this->setIfExists('end_date', $data, null);
        $this->setIfExists('promo_code_only', $data, null);
        $this->setIfExists('offers', $data, null);
        $this->setIfExists('brands', $data, null);
        $this->setIfExists('categories', $data, null);
        $this->setIfExists('segments', $data, null);
        $this->setIfExists('conditions', $data, null);
    }

    public function setIfExists(string $variableName, $fields, $defaultValue)
    {
        if (is_array($fields) && array_key_exists($variableName, $fields) && is_null($fields[$variableName]) && self::isNullable($variableName)) {
            array_push($this->openAPINullablesSetToNull, $variableName);
        }

        $this->container[$variableName] = isset($fields[$variableName]) ? $fields[$variableName] : $defaultValue;

        return $this;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets user_id
     *
     * @return int|null
     */
    public function getUserId()
    {
        return $this->container['user_id'];
    }

    /**
     * Sets user_id
     *
     * @param int|null $user_id Идентификатор пользователя
     *
     * @return $this
     */
    public function setUserId($user_id)
    {


        /*if (is_null($user_id)) {
            throw new \InvalidArgumentException('non-nullable user_id cannot be null');
        }*/
        $this->container['user_id'] = $user_id;

        return $this;
    }

    /**
     * Gets seller_id
     *
     * @return int|null
     */
    public function getSellerId()
    {
        return $this->container['seller_id'];
    }

    /**
     * Sets seller_id
     *
     * @param int|null $seller_id Идентификатор продавца
     *
     * @return $this
     */
    public function setSellerId($seller_id)
    {

        if (is_null($seller_id)) {
            array_push($this->openAPINullablesSetToNull, 'seller_id');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('seller_id', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['seller_id'] = $seller_id;

        return $this;
    }

    /**
     * Gets name
     *
     * @return string|null
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     *
     * @param string|null $name Наименование скидки
     *
     * @return $this
     */
    public function setName($name)
    {


        /*if (is_null($name)) {
            throw new \InvalidArgumentException('non-nullable name cannot be null');
        }*/
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets value_type
     *
     * @return int|null
     */
    public function getValueType()
    {
        return $this->container['value_type'];
    }

    /**
     * Sets value_type
     *
     * @param int|null $value_type Тип значения скидки из DiscountValueTypeEnum
     *
     * @return $this
     */
    public function setValueType($value_type)
    {


        /*if (is_null($value_type)) {
            throw new \InvalidArgumentException('non-nullable value_type cannot be null');
        }*/
        $this->container['value_type'] = $value_type;

        return $this;
    }

    /**
     * Gets value
     *
     * @return float|null
     */
    public function getValue()
    {
        return $this->container['value'];
    }

    /**
     * Sets value
     *
     * @param float|null $value Размер скидки
     *
     * @return $this
     */
    public function setValue($value)
    {


        /*if (is_null($value)) {
            throw new \InvalidArgumentException('non-nullable value cannot be null');
        }*/
        $this->container['value'] = $value;

        return $this;
    }

    /**
     * Gets status
     *
     * @return int|null
     */
    public function getStatus()
    {
        return $this->container['status'];
    }

    /**
     * Sets status
     *
     * @param int|null $status Статус скидки из DiscountStatusEnum
     *
     * @return $this
     */
    public function setStatus($status)
    {


        /*if (is_null($status)) {
            throw new \InvalidArgumentException('non-nullable status cannot be null');
        }*/
        $this->container['status'] = $status;

        return $this;
    }

    /**
     * Gets start_date
     *
     * @return \DateTime|null
     */
    public function getStartDate()
    {
        return $this->container['start_date'];
    }

    /**
     * Sets start_date
     *
     * @param \DateTime|null $start_date Дата начала действия скидки
     *
     * @return $this
     */
    public function setStartDate($start_date)
    {

        if (is_null($start_date)) {
            array_push($this->openAPINullablesSetToNull, 'start_date');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('start_date', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['start_date'] = $start_date;

        return $this;
    }

    /**
     * Gets end_date
     *
     * @return \DateTime|null
     */
    public function getEndDate()
    {
        return $this->container['end_date'];
    }

    /**
     * Sets end_date
     *
     * @param \DateTime|null $end_date Дата окончания действия скидки
     *
     * @return $this
     */
    public function setEndDate($end_date)
    {

        if (is_null($end_date)) {
            array_push($this->openAPINullablesSetToNull, 'end_date');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('end_date', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['end_date'] = $end_date;

        return $this;
    }

    /**
     * Gets promo_code_only
     *
     * @return bool|null
     */
    public function getPromoCodeOnly()
    {
        return $this->container['promo_code_only'];
    }

    /**
     * Sets promo_code_only
     *
     * @param bool|null $promo_code_only Скидка действительна только по промокоду
     *
     * @return $this
     */
    public function setPromoCodeOnly($promo_code_only)
    {


        /*if (is_null($promo_code_only)) {
            throw new \InvalidArgumentException('non-nullable promo_code_only cannot be null');
        }*/
        $this->container['promo_code_only'] = $promo_code_only;

        return $this;
    }

    /**
     * Gets offers
     *
     * @return \Ensi\MarketingClient\Dto\DiscountOffer[]|null
     */
    public function getOffers()
    {
        return $this->container['offers'];
    }

    /**
     * Sets offers
     *
     * @param \Ensi\MarketingClient\Dto\DiscountOffer[]|null $offers offers
     *
     * @return $this
     */
    public function setOffers($offers)
    {


        /*if (is_null($offers)) {
            throw new \InvalidArgumentException('non-nullable offers cannot be null');
        }*/
        $this->container['offers'] = $offers;

        return $this;
    }

    /**
     * Gets brands
     *
     * @return \Ensi\MarketingClient\Dto\DiscountBrand[]|null
     */
    public function getBrands()
    {
        return $this->container['brands'];
    }

    /**
     * Sets brands
     *
     * @param \Ensi\MarketingClient\Dto\DiscountBrand[]|null $brands brands
     *
     * @return $this
     */
    public function setBrands($brands)
    {


        /*if (is_null($brands)) {
            throw new \InvalidArgumentException('non-nullable brands cannot be null');
        }*/
        $this->container['brands'] = $brands;

        return $this;
    }

    /**
     * Gets categories
     *
     * @return \Ensi\MarketingClient\Dto\DiscountCategory[]|null
     */
    public function getCategories()
    {
        return $this->container['categories'];
    }

    /**
     * Sets categories
     *
     * @param \Ensi\MarketingClient\Dto\DiscountCategory[]|null $categories categories
     *
     * @return $this
     */
    public function setCategories($categories)
    {


        /*if (is_null($categories)) {
            throw new \InvalidArgumentException('non-nullable categories cannot be null');
        }*/
        $this->container['categories'] = $categories;

        return $this;
    }

    /**
     * Gets segments
     *
     * @return \Ensi\MarketingClient\Dto\DiscountSegment[]|null
     */
    public function getSegments()
    {
        return $this->container['segments'];
    }

    /**
     * Sets segments
     *
     * @param \Ensi\MarketingClient\Dto\DiscountSegment[]|null $segments segments
     *
     * @return $this
     */
    public function setSegments($segments)
    {


        /*if (is_null($segments)) {
            throw new \InvalidArgumentException('non-nullable segments cannot be null');
        }*/
        $this->container['segments'] = $segments;

        return $this;
    }

    /**
     * Gets conditions
     *
     * @return \Ensi\MarketingClient\Dto\DiscountCondition[]|null
     */
    public function getConditions()
    {
        return $this->container['conditions'];
    }

    /**
     * Sets conditions
     *
     * @param \Ensi\MarketingClient\Dto\DiscountCondition[]|null $conditions conditions
     *
     * @return $this
     */
    public function setConditions($conditions)
    {


        /*if (is_null($conditions)) {
            throw new \InvalidArgumentException('non-nullable conditions cannot be null');
        }*/
        $this->container['conditions'] = $conditions;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


